unit TimerTest;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Samples.Spin, Vcl.ExtCtrls, System.Diagnostics;

type
  TForm1 = class(TForm)
    Button1: TButton;
    SpinEdit1: TSpinEdit;
    Button2: TButton;
    Label1: TLabel;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    flgStop : Boolean;
    TimerThread : TThread;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=====================================================================
// TimerThread̏I҂܂
// FreeOnTerminate := Truȅꍇ
//              TimerThread = Nil
// FreeOnTerminate := Falsȅꍇ  (w̖ꍇ̓ftHgTrue)
//              TimerThread.Terminate
//              FreeAndNil(TimerThread)
// OnTerminatgpȒPłB
//=====================================================================
procedure WaitThread(TH: pointer);
begin
  WaitForSingleObject(integer(TH^), INFINITE);
  with Form1 do begin
    if Assigned(TimerThread) then begin
      flgStop := True;
      TimerThread.Terminate;
      FreeAndNil(TimerThread);
    end;
    Button3.Enabled := True;
  end;
  // WaitThreadXbhI
  EndThread(0);
end;

//==================================================================================
// CreateAnonymousThreadŃXbh쐬Ďs
// ^C}[̋N⎞Ԍo߂̊Ď̓Xbhōs܂
// TStopWatch̎gpɂ́CusesDiagnosticsKvł
// Button1.Enabled := False@RgAEgĎ { } Lɂ
// ^C}[̓r Button1NbNꎖɂ^C}[̃X^[go܂B
// (FreeOnTerminate := False ̕Kv܂)
//==================================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  AStopWatch : TStopWatch;
  FTimeValue : Int64;
  FTimeDis   : Int64;
  Amin       : Integer;
  dmp        : Int64;
  Asec       : Integer;
  msec       : Integer;
  id         : Cardinal;
begin
  if Assigned(TimerThread) then begin
    flgStop := True;
    TimerThread.Terminate;
    FreeAndNil(TimerThread);
  end;

  flgStop := False;
  // ^C}[Xbh̐
  TimerThread := TThread.CreateAnonymousThread(
    procedure
    begin
      AStopWatch := TStopwatch.StartNew;
      FTimeValue := SpinEdit1.Value;

      while true do begin
        // FTimeDis̒l͕b
        FTimeDis := FTimeValue * 1000 - AStopWatch.ElapsedMilliseconds;
        dmp      := FTimeDis mod 60000;
        Amin     := FTimeDis div 60000;
        Asec     := dmp div 1000;
        msec     :=(dmp mod 1000) div 100 * 100;
        TThread.Synchronize(TimerThread,
          procedure
          begin
            Label1.Caption := Format('c%4d%2db%3d_b', [Amin, Asec, msec]);
            Label1.Update;
          end
        );

        if flgStop       then break;
        if FTimeDis <= 0 then break;

        // ꂪȂCPUgpˏオ܂
        Sleep(10);
      end;
      // ĂOK
      AStopWatch.Stop;
      // ̃[vIr[v
      TThread.Synchronize(TimerThread,
        procedure
        begin
          Winapi.Windows.Beep(500, 1000);
        end
      );
    end
  );
  if Assigned(TimerThread) then begin
    Button3.Enabled := False;
    // XbhD揇
    TimerThread.Priority := tpNormal;
    // TimerThreadIĂXbhJȂw
    // wȂꍇ IɃXbhJ ftHg True
    TimerThread.FreeOnTerminate := False;
    TimerThread.Start;
    // TimerThread̏IĎXbh̐
    CloseHandle(BeginThread(nil, 0, addr(WaitThread), addr(TimerThread.Handle), 0, Id));
  end;
end;

//=============================================================================
//  ^C}[Xgbv
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
begin
  flgStop := True;
end;

//==============================================================
// tH[̃N[Y{^͔\̓OCAEgĂ
// Xbh̎svOIȂ悤ɂ܂
//==============================================================
procedure TForm1.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Label1.Caption := Format('c%4d%2db%3d_b', [0, 0, 0]);
end;

end.

