unit Timertest;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Samples.Spin, Vcl.ExtCtrls, System.Diagnostics;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
    procedure TimerThreadProc;
    procedure Enddisp(Tone, Time:integer);

  public
    { Public 錾 }
    TimerThread : TThread;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Xbh̕⏕[`
procedure TForm1.Enddisp(Tone, Time: integer);
begin
  Button1.Enabled := True;
  Button3.Enabled := True;
  Winapi.Windows.Beep(Tone, Time);
end;


//=============================================================================
// Xbhp\bh
// TStopWatch̎gpɂ́CusesDiagnosticsKvł
// StringgpĂ[[N͔܂
//=============================================================================
procedure TForm1.TimerThreadProc;
var
  AStopWatch : TStopWatch;
  FTimeValue : Int64;
  FTimeDis   : Int64;
  Amin       : Integer;
  Asec       : Integer;
  FSync      : TThreadProcedure;
  FSyncEnd   : TThreadProcedure;
begin
  // XbhÕvV[WĂяo\bh̒`
  FSync := procedure
  begin
    Label1.Caption := Format('c%4d%2db', [Amin, Asec]);
    Label1.Update;
  end;

  FSyncEnd := procedure
  begin
    Enddisp(700, 1000);
  end;

  //--------------- 艺{̃R[h -----------------
  AStopWatch := TStopwatch.StartNew;
  FTimeValue := SpinEdit1.Value;
  while not TimerThread.CheckTerminated do begin
    // FTimeDis̒l͕b
    FTimeDis := FTimeValue - AStopWatch.ElapsedMilliseconds div 1000;
    Amin     := FTimeDis div 60;
    Asec     := FTimeDis mod 60;

    TThread.Synchronize(TThread.CurrentThread, FSync);
    if FTimeDis <= 0 then TimerThread.Terminate;
    // ꂪȂCPUgpˏオ܂
    TThread.Sleep(1);
  end;

  // ̏I
  TThread.Synchronize(TThread.CurrentThread, FSyncEnd);
end;

//=============================================================================
// CreateAnonymousThreadŃXbh쐬Ďs܂
// ^C}[̋N⎞Ԍo߂̊Ď̓Xbhōs܂
// CreateAnonymousThread̓ftHg FreeOnTerminate True ł
// XbhIIɊJ܂
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  Button1.Enabled := False;
  Button3.Enabled := False;
  TimerThread := TThread.CreateAnonymousThread(TimerThreadProc);
  TimerThread.Start;
end;

//=============================================================================
//  Xbh̒~
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
begin
  TimerThread.Terminate;
end;

//==============================================================
// tH[̃N[Y{^͔\̓OCAEgĂ
// Xbh̎svOIȂ悤ɂ܂
//==============================================================
procedure TForm1.Button3Click(Sender: TObject);
begin
  Close;
end;

end.
